<!DOCTYPE html>
<html lang="en">
<head>
  <title>Task64.30</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Quản trị đồ uống</h2>
  <div class="row">
	<div class="col-sm-12">
		<button id="btn-clear-data" class="btn btn-danger">Delete All Data</button>
	</div>
  </div>
	<div class="jumbotron container">
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="drink-code">Mã Nước uống</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-drink-code" name="drink-code" placeholder="drink code"
			class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="drink-name">Tên Nước uống</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-drink-name" name="drink-name" placeholder="drink name"
			class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="price">Đơn giá</label>
		</div>
		<div class="col-sm-9">
		  <input type="number" id="input-price" name="price" placeholder="price" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="note">Ghi chú</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="createDate">Ngày Tạo</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="updateDate">Ngày sửa</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control">
		</div>
	  </div>
	  <div class="row pull-right">
		<div class = "col-sm-3">
		</div>
		<div class="col-sm-3">
		  <button id="btn-update-drink" class="btn btn-info">Update drink</button>
		</div>
		<div class="col-sm-3">
			<button id="btn-delete-drink" class="btn btn-danger">Delete drink</button>
		</div>
		<div class="col-sm-3">
			<button id="btn-create-drink" class="btn btn-success">Add New drink</button>
		</div>
	  </div>
	</div>
  <table class="table table-bordered table-striped table-hover" id="user-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã nước uống</th>
		<th>Tên nước uống</th>
        <th>Đơn giá</th>
        <th>Ghi Chú</th>
        <th>Ngày tạo</th>
        <th>Ngày cập nhật</th>
      </tr>
  </table>
</div>
<script>
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
// Biến toàn cục để lưu trữ id drink đang đc update or delete. Mặc định = 0;
var gdrinkId = 0;
const gBASE_URL = "http://localhost:8080/drinks/";
const gCONTENT_TYPE = "application/json;charset=UTF-8";

$(document).ready(function(){
	var table = $("#user-table").DataTable({
		"columns": [
			{"data":"id"},
			{"data":"maNuocUong"},
			{"data":"tenNuocUong"},
			{"data":"price"},
			{"data":"ghiChu"},
			{"data":"ngayTao"},
			{"data":"ngayCapNhat"},
		]
	})
	$.ajax({
		url: gBASE_URL,
		type: "GET",
		dataType: "json",
		success: function(res){
			console.log(res);
			table.clear();
			table.rows.add(res);
			table.draw();
		},
		error: function(err){
			console.log(err.response);
		}
	})
		
	/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
	//Subtask 1- add click event to all rows
	$("#user-table").on("click", "tr", function(){
		onRowClick(this);
	})
	//task 2 - Update drink: add event to save data button
	$("#btn-update-drink").on("click",function(){
		onUpdateButtonClick();
	});
	//task 3 - Create new drink
	$("#btn-create-drink").on("click",function(){
		onCreateButtonClick();
	});
	//task 4 - Delete drink selected
	$("#btn-delete-drink").on("click",function(){
		onDeleteButtonClick();
	});
	//task 5 - Delete all drinks
	$("#btn-clear-data").on("click",function(){
		onDeleteAllBtnClick();
	});
	/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 
	//hàm xử lý sự kiện click row
	function onRowClick(paramRow){
		gDrinkId = $(paramRow).find("td:eq(0)").html();
		console.log("Drink id of selected row: " + gDrinkId);
		//lấy thông tin drink của row được click và hiển thị lên form
		var vDrink = callApiGetDrinkById(gDrinkId);
	};
	
	//hàm xử lý sự kiện nút save data
	function onUpdateButtonClick(){
		//khai báo drink obj
		var vDrinkObj = {
			maNuocUong: "",
			tenNuocUong: "",
			price: -1,
			ghiChu:"",
		}
		// B1: Thu thập dữ liệu
		getUpdateDrinkData(vDrinkObj);
		// B2: Validate update
		var vIsDrinkValidate = validateDrinkData(vDrinkObj);
    	if (vIsDrinkValidate){
			// B3: update drink
			$.ajax({
				url: gBASE_URL + gDrinkId,
				type: "PUT",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vDrinkObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleUpdateDrinkSuccess();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
	}
	
	//hàm xử lý sự kiện nút thêm drink
	function onCreateButtonClick(){
		//khai báo drink obj
		var vDrinkObj = {
			maNuocUong: "",
			tenNuocUong: "",
			price: -1,
			ghiChu:"",
		}
		// B1: Thu thập dữ liệu
		getUpdateDrinkData(vDrinkObj);
		// B2: Validate data
		var vIsDrinkValidate = validateDrinkData(vDrinkObj);
    	if (vIsDrinkValidate){
			// B3: create drink
			$.ajax({
				url: gBASE_URL,
				type: "POST",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vDrinkObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleCreatedrinkSuccess();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
	}
	//hàm xử lý sự kiện nút xóa drink được chọn và hiển thị trên form
	function onDeleteButtonClick(){
    //b1: thu thập dữ liệu
    //b2: validate
    //b3: thực hiện xóa - gọi API
      $.ajax({
        url: gBASE_URL + gDrinkId,
        type: "DELETE",
        success: function(paramRes) {
          handleDeleteDrinkSuccess();
        },
        error: function(paramErr) {
          alert("Xóa drink không thành công");
        }
      });
	}
	function onDeleteAllBtnClick(){
    //b3: thực hiện xóa - gọi API
      $.ajax({
        url: gBASE_URL,
        type: "DELETE",
        success: function(paramRes) {
          alert("Tất cả các drinks trong database đã được xóa!");
        },
        error: function(paramErr) {
          alert("Xóa database không thành công");
        }
      });
	}
	/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
	//hàm gọi API lấy thông tin drink của dòng được chọn
	function callApiGetDrinkById(paramId){
		$.ajax({
			url: gBASE_URL + paramId,
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res);
				displayDrinkData(res);
			},
			error: function(err){
				console.log(err.responseText);
			}
		})
	}
	//hàm hiển thị thông tin drink của dòng được click
	function displayDrinkData(paramDrink){
		$("#input-drink-code").val(paramDrink.maNuocUong);
		$("#input-drink-name").val(paramDrink.tenNuocUong);
		$("#input-price").val(paramDrink.price); 
		$("#input-note").val(paramDrink.ghiChu); 
		$("#input-createDate").val(paramDrink.ngayTao); 
		$("#input-updateDate").val(paramDrink.ngayCapNhat);  
	}
	// hàm thu thập dữ liệu để update drink
	function getUpdateDrinkData(paramDrinkObj) {
		paramDrinkObj.maNuocUong =$("#input-drink-code").val().trim();
		paramDrinkObj.tenNuocUong =$("#input-drink-name").val().trim();
		paramDrinkObj.price = parseInt($("#input-price").val()); 
		paramDrinkObj.ghiChu = $("#input-note").val().trim(); 
	}

	// hàm validate data
	function validateDrinkData(paramDrinkObj) {
		if (paramDrinkObj.maNuocUong === "") {
		alert("Cần nhập mã nước uống");
		return false;
		}
		if (paramDrinkObj.tenNuocUong === "") {
		alert("Cần nhập tên nước uống");
		return false;
		}
		if (isNaN(paramDrinkObj.price)) {
		alert("Đơn giá cần nhập vào phải là số");
		return false;
		}

		return true;
	}
	
	//hiển thị cập nhật drink thành công
	function handleUpdateDrinkSuccess(){
		alert("Sửa drink có id: " + gDrinkId + " thành công!");
	};
	//hiển thị thêm drink thành công
	function handleCreateDrinkSuccess(){
		alert("Thêm drink thành công!");
	};
	//hiển thị cập nhật drink thành công
	function handleDeleteDrinkSuccess(){
		alert("Xóa drink có id: " + gDrinkId + " thành công!");
	};
})
</script>
</body>
</html>
